Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/AdminHomePage.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/AdminHomePage.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/AdminHomePage.java	(revision 5549)
@@ -29,6 +29,7 @@
 import clarin.cmdi.componentregistry.ComponentRegistryException;
 import clarin.cmdi.componentregistry.ComponentRegistryFactory;
-import clarin.cmdi.componentregistry.ComponentStatus;
 import clarin.cmdi.componentregistry.MDMarshaller;
+import clarin.cmdi.componentregistry.RegistrySpace;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.impl.database.AdminRegistry;
 import clarin.cmdi.componentregistry.model.BaseDescription;
@@ -43,5 +44,5 @@
     private final static Logger LOG = LoggerFactory.getLogger(AdminHomePage.class);
     private final CMDItemInfo info;
-    private final LinkTree tree;
+    private LinkTree tree;
     private transient AdminRegistry adminRegistry = new AdminRegistry();
     @SpringBean(name = "componentRegistryFactory")
@@ -53,246 +54,246 @@
 
     public AdminHomePage(final PageParameters parameters) throws ComponentRegistryException {
-	super(parameters);
-	adminRegistry.setComponentRegistryFactory(componentRegistryFactory);
-	adminRegistry.setComponentDao(componentDao);
-	adminRegistry.setMarshaller(marshaller);
-	info = new CMDItemInfo(marshaller);
-	addLinks();
-	final FeedbackPanel feedback = new FeedbackPanel("feedback");
-	feedback.setOutputMarkupId(true);
-	add(feedback);
-	Form form = new ItemEditForm("form");
-	add(form);
-
-	Button deleteButton = new AjaxFallbackButton("delete", form) {
-
-	    @Override
-	    protected void onSubmit(AjaxRequestTarget target, Form<?> form) {
-		CMDItemInfo info = (CMDItemInfo) form.getModelObject();
-		info("deleting:" + info.getName());
-		Principal userPrincipal = getWebRequest().getHttpServletRequest().getUserPrincipal();
-		try {
-		    adminRegistry.delete(info, userPrincipal);
-		    info("Item deleted.");
-		    reloadTreeModel(info);
-		} catch (SubmitFailedException e) {
-		    LOG.error("Admin: ", e);
-		    error("Cannot delete: " + info.getName() + "\n error=" + e);
-		}
-		if (target != null) {
-		    target.addComponent(form);
-		    target.addComponent(tree);
-		    target.addComponent(feedback);
-		}
-	    }
-
-	    @Override
-	    public boolean isEnabled() {
-		return info.isDeletable();
-
-	    }
-	;
-	};
+        super(parameters);
+        adminRegistry.setComponentRegistryFactory(componentRegistryFactory);
+        adminRegistry.setComponentDao(componentDao);
+        adminRegistry.setMarshaller(marshaller);
+        info = new CMDItemInfo(marshaller);
+        addLinks();
+        final FeedbackPanel feedback = new FeedbackPanel("feedback");
+        feedback.setOutputMarkupId(true);
+        add(feedback);
+        Form form = new ItemEditForm("form");
+        add(form);
+
+        Button deleteButton = new AjaxFallbackButton("delete", form) {
+            @Override
+            protected void onSubmit(AjaxRequestTarget target, Form<?> form) {
+                CMDItemInfo info = (CMDItemInfo) form.getModelObject();
+                info("deleting:" + info.getName());
+                Principal userPrincipal = getWebRequest().getHttpServletRequest().getUserPrincipal();
+                try {
+                    adminRegistry.delete(info, userPrincipal);
+                    info("Item deleted.");
+                    reloadTreeModel(info);
+                } catch (Exception e) {
+                    LOG.error("Admin: ", e);
+                    error("Cannot delete: " + info.getName() + "\n error=" + e);
+                }
+                if (target != null) {
+                    target.addComponent(form);
+                    target.addComponent(tree);
+                    target.addComponent(feedback);
+                }
+            }
+
+            @Override
+            public boolean isEnabled() {
+                return info.isDeletable();
+
+            }
+        ;
+        };
 	form.add(deleteButton);
 
-	Button undeleteButton = new AjaxFallbackButton("undelete", form) {
-
-	    @Override
-	    protected void onSubmit(AjaxRequestTarget target, Form<?> form) {
-		CMDItemInfo info = (CMDItemInfo) form.getModelObject();
-		info("undeleting:" + info.getName());
-		try {
-		    adminRegistry.undelete(info);
-		    info("Item put back.");
-		    reloadTreeModel(info);
-		} catch (SubmitFailedException e) {
-		    LOG.error("Admin: ", e);
-		    error("Cannot undelete: " + info.getName() + "\n error=" + e);
-		}
-		if (target != null) {
-		    target.addComponent(form);
-		    target.addComponent(tree);
-		    target.addComponent(feedback);
-		}
-	    }
-
-	    @Override
-	    public boolean isEnabled() {
-		return info.isUndeletable();
-	    }
-	};
-	form.add(undeleteButton);
-
-	CheckBox forceUpdateCheck = new CheckBox("forceUpdate");
-	form.add(forceUpdateCheck);
-
-	Button submitButton = new AjaxFallbackButton("submit", form) {
-
-	    @Override
-	    protected void onSubmit(AjaxRequestTarget target, Form<?> form) {
-		CMDItemInfo info = (CMDItemInfo) form.getModelObject();
-		Principal userPrincipal = getWebRequest().getHttpServletRequest().getUserPrincipal();
-		info("submitting:" + info.getName() + " id=(" + info.getDataNode().getDescription().getId() + ")");
-		try {
-		    adminRegistry.submitFile(info, userPrincipal);
-		    info("submitting done.");
-		    reloadTreeModel(info);
-		} catch (SubmitFailedException e) {
-		    LOG.error("Admin: ", e);
-		    error("Cannot submit: " + info.getName() + "\n error=" + e);
-		}
-		if (target != null) {
-		    target.addComponent(form);
-		    target.addComponent(tree);
-		    target.addComponent(feedback);
-		}
-	    }
-
-	    @Override
-	    public boolean isEnabled() {
-		return info.isEditable();
-	    }
-	};
-	form.add(submitButton);
-
-	tree = createTree("tree", form, createDBTreeModel());
-	add(tree);
-	add(new Link("expandAll") {
-
-	    @Override
-	    public void onClick() {
-		tree.getTreeState().expandAll();
-	    }
-	});
-
-	add(new Link("collapseAll") {
-
-	    @Override
-	    public void onClick() {
-		tree.getTreeState().collapseAll();
-	    }
-	});
-
-    }
-
-    private void reloadTreeModel(CMDItemInfo info) {
-	try {
-	    tree.setModelObject(createDBTreeModel());
-	} catch (ComponentRegistryException e) {
-	    LOG.error("Admin: ", e);
-	    error("Cannot reload tree: " + info.getName() + "\n error=" + e);
-	}
+        Button undeleteButton = new AjaxFallbackButton("undelete", form) {
+            @Override
+            protected void onSubmit(AjaxRequestTarget target, Form<?> form) {
+                CMDItemInfo info = (CMDItemInfo) form.getModelObject();
+                info("undeleting:" + info.getName());
+                try {
+                    adminRegistry.undelete(info);
+                    info("Item put back.");
+                    reloadTreeModel(info);
+                } catch (Exception e) {
+                    LOG.error("Admin: ", e);
+                    error("Cannot undelete: " + info.getName() + "\n error=" + e);
+                }
+                if (target != null) {
+                    target.addComponent(form);
+                    target.addComponent(tree);
+                    target.addComponent(feedback);
+                }
+            }
+
+            @Override
+            public boolean isEnabled() {
+                return info.isUndeletable();
+            }
+        };
+        form.add(undeleteButton);
+
+        CheckBox forceUpdateCheck = new CheckBox("forceUpdate");
+        form.add(forceUpdateCheck);
+
+        Button submitButton = new AjaxFallbackButton("submit", form) {
+            @Override
+            protected void onSubmit(AjaxRequestTarget target, Form<?> form) {
+                CMDItemInfo info = (CMDItemInfo) form.getModelObject();
+                Principal userPrincipal = getWebRequest().getHttpServletRequest().getUserPrincipal();
+                info("submitting:" + info.getName() + " id=(" + info.getDataNode().getDescription().getId() + ")");
+                try {
+                    adminRegistry.submitFile(info, userPrincipal);
+                    info("submitting done.");
+                    reloadTreeModel(info);
+                } catch (Exception e) {
+                    LOG.error("Admin: ", e);
+                    error("Cannot submit: " + info.getName() + "\n error=" + e);
+                }
+                if (target != null) {
+                    target.addComponent(form);
+                    target.addComponent(tree);
+                    target.addComponent(feedback);
+                }
+            }
+
+            @Override
+            public boolean isEnabled() {
+                return info.isEditable();
+            }
+        };
+        form.add(submitButton);
+
+
+
+
+        try {
+            tree = createTree("tree", form, createDBTreeModel());
+            add(tree);
+            add(new Link("expandAll") {
+                @Override
+                public void onClick() {
+                    tree.getTreeState().expandAll();
+                }
+            });
+
+            add(new Link("collapseAll") {
+                @Override
+                public void onClick() {
+                    tree.getTreeState().collapseAll();
+                }
+            });
+
+        } catch (UserUnauthorizedException e) {            
+            LOG.error("Admin: ", e);
+            error("Cannot create tree: error = " + e);
+        }
+        
+    }
+
+    private void reloadTreeModel(CMDItemInfo info) throws UserUnauthorizedException {
+        try {
+            tree.setModelObject(createDBTreeModel());
+        } catch (ComponentRegistryException e) {
+            LOG.error("Admin: ", e);
+            error("Cannot reload tree: " + info.getName() + "\n error=" + e);
+        }
     }
 
     private void addLinks() {
-	add(new Label("linksMessage", "Browse the data below or choose on of the following options:"));
-	add(new Link("massMigrate") {
-
-	    @Override
-	    public void onClick() {
-		setResponsePage(MassMigratePage.class);
-	    }
-	});
-	add(new Link("log") {
-
-	    @Override
-	    public void onClick() {
-		setResponsePage(ViewLogPage.class);
-	    }
-	});
-	add(new Link("statistics") {
-
-	    @Override
-	    public void onClick() {
-		setResponsePage(StatisticsPage.class);
-	    }
-	});
+        add(new Label("linksMessage", "Browse the data below or choose on of the following options:"));
+        add(new Link("massMigrate") {
+            @Override
+            public void onClick() {
+                setResponsePage(MassMigratePage.class);
+            }
+        });
+        add(new Link("log") {
+            @Override
+            public void onClick() {
+                setResponsePage(ViewLogPage.class);
+            }
+        });
+        add(new Link("statistics") {
+            @Override
+            public void onClick() {
+                setResponsePage(StatisticsPage.class);
+            }
+        });
     }
 
     private LinkTree createTree(String id, final Form form, TreeModel treeModel) {
-	final LinkTree adminTree = new LinkTree(id, treeModel) {
-
-	    @Override
-	    protected void onNodeLinkClicked(Object node, BaseTree tree, AjaxRequestTarget target) {
-		super.onNodeLinkClicked(node, tree, target);
-		ITreeState treeState = tree.getTreeState();
-		if (treeState.isNodeExpanded(node)) {
-		    treeState.collapseNode(node);
-		} else {
-		    treeState.expandNode(node);
-		}
-		DisplayDataNode dn = (DisplayDataNode) ((DefaultMutableTreeNode) node).getUserObject();
-		info.setDataNode(dn);
-		BaseDescription desc = dn.getDescription();
-		if (desc != null) {
-		    String content = componentDao.getContent(dn.isDeleted(), desc.getId());
-		    info.setContent(content);
-		}
-		if (target != null) {
-		    target.addComponent(form);
-		}
-	    }
-	};
-	return adminTree;
+        final LinkTree adminTree = new LinkTree(id, treeModel) {
+            @Override
+            protected void onNodeLinkClicked(Object node, BaseTree tree, AjaxRequestTarget target) {
+                super.onNodeLinkClicked(node, tree, target);
+                ITreeState treeState = tree.getTreeState();
+                if (treeState.isNodeExpanded(node)) {
+                    treeState.collapseNode(node);
+                } else {
+                    treeState.expandNode(node);
+                }
+                DisplayDataNode dn = (DisplayDataNode) ((DefaultMutableTreeNode) node).getUserObject();
+                info.setDataNode(dn);
+                BaseDescription desc = dn.getDescription();
+                if (desc != null) {
+                    String content = componentDao.getContent(dn.isDeleted(), desc.getId());
+                    info.setContent(content);
+                }
+                if (target != null) {
+                    target.addComponent(form);
+                }
+            }
+        };
+        return adminTree;
     }
 
     private class ItemEditForm extends Form<CMDItemInfo> {
 
-	public ItemEditForm(String name) {
-	    super(name);
-	    CompoundPropertyModel model = new CompoundPropertyModel(info);
-	    setModel(model);
-
-	    TextArea descriptionArea = new TextArea("description");
-	    descriptionArea.setOutputMarkupId(true);
-	    add(descriptionArea);
-	    TextArea contentArea = new TextArea("content");
-	    contentArea.setOutputMarkupId(true);
-	    add(contentArea);
-	}
-    }
-
-    private TreeModel createDBTreeModel() throws ComponentRegistryException {
-	DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode(new DisplayDataNode("ComponentRegistry", false));
-	DefaultMutableTreeNode publicNode = new DefaultMutableTreeNode(new DisplayDataNode("Public", false));
-	rootNode.add(publicNode);
-	ComponentRegistry publicRegistry = componentRegistryFactory.getPublicRegistry();
-	add(publicNode, publicRegistry);
-	List<ComponentRegistry> userRegistries = componentRegistryFactory.getAllUserRegistries();
-	for (ComponentRegistry registry : userRegistries) {
-	    DefaultMutableTreeNode userNode = new DefaultMutableTreeNode(new DisplayDataNode(registry.getName(), false));
-	    rootNode.add(userNode);
-	    add(userNode, registry);
-	}
-	TreeModel model = new DefaultTreeModel(rootNode);
-	return model;
-    }
-
-    private void add(DefaultMutableTreeNode parent, ComponentRegistry registry) throws ComponentRegistryException {
-	DefaultMutableTreeNode componentsNode = new DefaultMutableTreeNode(new DisplayDataNode("Components", false));
-	parent.add(componentsNode);
-	add(componentsNode, registry.getComponentDescriptions(), false, registry.getStatus());
-
-	DefaultMutableTreeNode profilesNode = new DefaultMutableTreeNode(new DisplayDataNode("Profiles", false));
-	parent.add(profilesNode);
-	add(profilesNode, registry.getProfileDescriptions(), false, registry.getStatus());
-
-	DefaultMutableTreeNode deletedCompNode = new DefaultMutableTreeNode(new DisplayDataNode("Deleted Components", true));
-	parent.add(deletedCompNode);
-
-	List<ComponentDescription> deletedComponentDescriptions = registry.getDeletedComponentDescriptions();
-	add(deletedCompNode, deletedComponentDescriptions, true, registry.getStatus());
-
-	DefaultMutableTreeNode deletedProfNode = new DefaultMutableTreeNode(new DisplayDataNode("Deleted Profiles", true));
-	parent.add(deletedProfNode);
-	List<ProfileDescription> deletedProfileDescriptions = registry.getDeletedProfileDescriptions();
-	add(deletedProfNode, deletedProfileDescriptions, true, registry.getStatus());
-    }
-
-    private void add(DefaultMutableTreeNode parent, List<? extends BaseDescription> descs, boolean isDeleted, ComponentStatus status) {
-	for (BaseDescription desc : descs) {
-	    DefaultMutableTreeNode child = new DefaultMutableTreeNode(new DisplayDataNode(desc.getName(), isDeleted, desc, status));
-	    parent.add(child);
-	}
+        public ItemEditForm(String name) {
+            super(name);
+            CompoundPropertyModel model = new CompoundPropertyModel(info);
+            setModel(model);
+
+            TextArea descriptionArea = new TextArea("description");
+            descriptionArea.setOutputMarkupId(true);
+            add(descriptionArea);
+            TextArea contentArea = new TextArea("content");
+            contentArea.setOutputMarkupId(true);
+            add(contentArea);
+        }
+    }
+
+    private TreeModel createDBTreeModel() throws ComponentRegistryException, UserUnauthorizedException {
+        DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode(new DisplayDataNode("ComponentRegistry", false));
+        DefaultMutableTreeNode publicNode = new DefaultMutableTreeNode(new DisplayDataNode("Public", false));
+        rootNode.add(publicNode);
+        ComponentRegistry publicRegistry = componentRegistryFactory.getPublicRegistry();
+        add(publicNode, publicRegistry);
+        List<ComponentRegistry> userRegistries = componentRegistryFactory.getAllUserRegistries();
+        for (ComponentRegistry registry : userRegistries) {
+            DefaultMutableTreeNode userNode = new DefaultMutableTreeNode(new DisplayDataNode(registry.getName(), false));
+            rootNode.add(userNode);
+            add(userNode, registry);
+        }
+        TreeModel model = new DefaultTreeModel(rootNode);
+        return model;
+    }
+
+    private void add(DefaultMutableTreeNode parent, ComponentRegistry registry) throws ComponentRegistryException, UserUnauthorizedException {
+        DefaultMutableTreeNode componentsNode = new DefaultMutableTreeNode(new DisplayDataNode("Components", false));
+        parent.add(componentsNode);
+        add(componentsNode, registry.getComponentDescriptions(), false, registry.getRegistrySpace());
+
+        DefaultMutableTreeNode profilesNode = new DefaultMutableTreeNode(new DisplayDataNode("Profiles", false));
+        parent.add(profilesNode);
+        add(profilesNode, registry.getProfileDescriptions(), false, registry.getRegistrySpace());
+
+        DefaultMutableTreeNode deletedCompNode = new DefaultMutableTreeNode(new DisplayDataNode("Deleted Components", true));
+        parent.add(deletedCompNode);
+
+        List<ComponentDescription> deletedComponentDescriptions = registry.getDeletedComponentDescriptions();
+        add(deletedCompNode, deletedComponentDescriptions, true, registry.getRegistrySpace());
+
+        DefaultMutableTreeNode deletedProfNode = new DefaultMutableTreeNode(new DisplayDataNode("Deleted Profiles", true));
+        parent.add(deletedProfNode);
+        List<ProfileDescription> deletedProfileDescriptions = registry.getDeletedProfileDescriptions();
+        add(deletedProfNode, deletedProfileDescriptions, true, registry.getRegistrySpace());
+    }
+
+    private void add(DefaultMutableTreeNode parent, List<? extends BaseDescription> descs, boolean isDeleted, RegistrySpace space) {
+        for (BaseDescription desc : descs) {
+            DefaultMutableTreeNode child = new DefaultMutableTreeNode(new DisplayDataNode(desc.getName(), isDeleted, desc, space));
+            parent.add(child);
+        }
     }
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/CMDItemInfo.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/CMDItemInfo.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/CMDItemInfo.java	(revision 5549)
@@ -1,8 +1,8 @@
 package clarin.cmdi.componentregistry.frontend;
 
-import clarin.cmdi.componentregistry.ComponentStatus;
 import java.io.Serializable;
 
 import clarin.cmdi.componentregistry.MDMarshaller;
+import clarin.cmdi.componentregistry.RegistrySpace;
 import clarin.cmdi.componentregistry.model.BaseDescription;
 
@@ -99,6 +99,6 @@
 
     
-    public ComponentStatus getStatus() {
-	return displayNode.getStatus();
+    public RegistrySpace getSpace() {
+	return displayNode.getSpace();
     }
 	
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/DisplayDataNode.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/DisplayDataNode.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/DisplayDataNode.java	(revision 5549)
@@ -2,4 +2,5 @@
 
 import clarin.cmdi.componentregistry.ComponentStatus;
+import clarin.cmdi.componentregistry.RegistrySpace;
 import java.io.Serializable;
 
@@ -12,16 +13,16 @@
     private final boolean isDeleted;
     private BaseDescription desc;
-    private final ComponentStatus status;
+    private final RegistrySpace space;
 
     public DisplayDataNode(String name, boolean isDeleted) {
 	// TODO: what is sensible default status?
-	this(name, isDeleted, null, ComponentStatus.PRIVATE);
+	this(name, isDeleted, null, RegistrySpace.PRIVATE);
     }
 
-    public DisplayDataNode(String name, boolean isDeleted, BaseDescription desc, ComponentStatus status) {
+    public DisplayDataNode(String name, boolean isDeleted, BaseDescription desc, RegistrySpace space) {
 	this.name = name;
 	this.isDeleted = isDeleted;
 	this.desc = desc;
-	this.status = status;
+	this.space = space;
     }
 
@@ -44,6 +45,6 @@
     }
 
-    public ComponentStatus getStatus() {
-	return status;
+    public RegistrySpace getSpace() {
+	return space;
     }
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/StatisticsPage.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/StatisticsPage.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/frontend/StatisticsPage.java	(revision 5549)
@@ -14,4 +14,6 @@
 import clarin.cmdi.componentregistry.ComponentRegistryException;
 import clarin.cmdi.componentregistry.ComponentRegistryFactory;
+import clarin.cmdi.componentregistry.RegistrySpace;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
 import clarin.cmdi.componentregistry.components.CMDComponentType;
@@ -40,12 +42,12 @@
     }
 
-    public StatisticsPage(final PageParameters pageParameters) throws IOException, ComponentRegistryException {
+    public StatisticsPage(final PageParameters pageParameters) throws IOException, ComponentRegistryException, UserUnauthorizedException {
         super(pageParameters);
-        ComponentRegistry registry = componentRegistryFactory.getPublicRegistry();
+        ComponentRegistry registry = componentRegistryFactory.getComponentRegistry(RegistrySpace.PUBLISHED, null, null, null);
         addLinks();
         displayStatistics(registry);
     }
 
-    private void displayStatistics(ComponentRegistry registry) throws ComponentRegistryException {
+    private void displayStatistics(ComponentRegistry registry) throws ComponentRegistryException, UserUnauthorizedException {
         List<ProfileDescription> profileList = registry.getProfileDescriptions();
         RepeatingView repeating = new RepeatingView("repeating");
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/ComponentRegistryImplBase.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/ComponentRegistryImplBase.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/ComponentRegistryImplBase.java	(revision 5549)
@@ -14,11 +14,10 @@
 import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.ComponentRegistryException;
-import clarin.cmdi.componentregistry.DeleteFailedException;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
 import clarin.cmdi.componentregistry.MDMarshaller;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
-import clarin.cmdi.componentregistry.components.CMDComponentType;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec.Header;
 import clarin.cmdi.componentregistry.model.BaseDescription;
-import clarin.cmdi.componentregistry.model.ComponentDescription;
 import clarin.cmdi.componentregistry.model.ProfileDescription;
 
@@ -33,32 +32,5 @@
     protected abstract MDMarshaller getMarshaller();
 
-    @Override
-    public List<ComponentDescription> getUsageInComponents(String componentId) throws ComponentRegistryException {
-        LOG.debug("Checking usage of component {} in components", componentId);
-        List<ComponentDescription> result = new ArrayList<ComponentDescription>();
-        List<String> ids = getAllNonDeletedComponentIds();
-        for (String id : ids) {
-            CMDComponentSpec spec = getMDComponent(id);
-            if (spec != null && hasComponentId(componentId, spec.getCMDComponent())) {
-                LOG.debug("Component {} used in component {}", componentId, spec.getHeader().getID());
-                result.add(getComponentDescription(id));
-            }
-        }
-        return result;
-    }
-
-    @Override
-    public List<ProfileDescription> getUsageInProfiles(String componentId) throws ComponentRegistryException {
-        LOG.debug("Checking usage of component {} in profiles", componentId);
-        List<ProfileDescription> result = new ArrayList<ProfileDescription>();
-        for (String id : getAllNonDeletedProfileIds()) {
-            CMDComponentSpec profile = getMDProfile(id);
-            if (profile != null && hasComponentId(componentId, profile.getCMDComponent())) {
-                LOG.debug("Component {} used in profile {}", componentId, profile.getHeader().getID());
-                result.add(getProfileDescription(id));
-            }
-        }
-        return result;
-    }
+    
 
     /**
@@ -70,5 +42,5 @@
     @Override
     public List<ProfileDescription> getProfileDescriptionsForMetadaEditor() throws ComponentRegistryException {
-	// TODO: Below can also be done by accepting and passing a parameter in the ProfileDescriptionDaoImpl, should have better performance
+        // TODO: Below can also be done by accepting and passing a parameter in the ProfileDescriptionDaoImpl, should have better performance
 
         // Get all profile descriptions
@@ -77,8 +49,13 @@
         ArrayList<ProfileDescription> descriptions = new ArrayList<ProfileDescription>();
         for (String id : descriptionsCollectionIds) {
-            ProfileDescription profile = getProfileDescription(id);
-            if (profile.isShowInEditor()) {
-                descriptions.add(profile);
+            try {
+                ProfileDescription profile = getProfileDescriptionAccessControlled(id);
+                if (profile.isShowInEditor()) {
+                    descriptions.add(profile);
+                }
+            } catch (UserUnauthorizedException e) {
+            } catch (ItemNotFoundException e) {
             }
+
         }
         // Return filtered list
@@ -102,22 +79,7 @@
     }
 
-    protected static boolean findComponentId(String componentId, List<CMDComponentType> componentReferences) {
-        for (CMDComponentType cmdComponent : componentReferences) {
-            if (hasComponentId(componentId, cmdComponent)) {
-                return true;
-            }
-        }
-        return false;
-    }
-
-    private static boolean hasComponentId(String componentId, CMDComponentType cmdComponent) {
-        if (componentId.equals(cmdComponent.getComponentId())) {
-            return true;
-        } else if (findComponentId(componentId, cmdComponent.getCMDComponent())) {
-            return true;
-        } else {
-            return false;
-        }
-    }
+    
+   
+    
 
     protected void writeXsd(CMDComponentSpec expandedSpec, OutputStream outputStream) {
@@ -135,24 +97,3 @@
     }
 
-    protected void checkStillUsed(String componentId) throws DeleteFailedException, ComponentRegistryException {
-        for (String id : getAllNonDeletedProfileIds()) {
-            CMDComponentSpec spec = getMDProfile(id);
-            if (spec != null && hasComponentId(componentId, spec.getCMDComponent())) {
-                LOG.warn("Cannot delete component {}, still used in profile {} and possibly other profiles and/or components", componentId, spec.getHeader().getID());
-                // Profile match - throw
-                throw new DeleteFailedException("Component is still in use by other components or profiles. Request component usage for details.");
-            }
-        }
-
-        LOG.debug("Component {} is not used in any profiles", componentId);
-
-        for (String id : getAllNonDeletedComponentIds()) {
-            CMDComponentSpec spec = getMDComponent(id);
-            if (spec != null && hasComponentId(componentId, spec.getCMDComponent())) {
-                LOG.warn("Cannot delete component {}, still used in component {} and possibly other components", componentId, spec.getHeader().getID());
-                // Component match -> throw
-                throw new DeleteFailedException("Component is still in use by one or more other components. Request component usage for details.");
-            }
-        }
-    }
 }
